image:
  name: gitlab-registry.oit.duke.edu/oit-dcc/apptainer-ci/apptainer-ci:latest
  entrypoint: ["/bin/sh", "-c"]

stages:
  - build
  - deploy_latest
  - deploy_tag

build:
  variables:
    SINGULARITYENV_CI_COMMIT_SHORT_SHA: ${CI_COMMIT_SHORT_SHA}
    SINGULARITYENV_GITHUB_PAT: ${GITHUB_PAT}
  rules:
    - changes:
      - Singularity.def
  stage: build
  script:
    - apptainer build ${CI_PROJECT_NAME}.sif Singularity.def
  artifacts:
    paths:
      - ${CI_PROJECT_NAME}.sif
    untracked: false
    expire_in: 48 hours
  tags:
    - oit-shared

deploy_latest:
  stage: deploy_latest
  rules:
    - if: '$CI_COMMIT_TAG != null'
      when: never
    - changes:
      - Singularity.def
  variables:
    APPTAINER_DOCKER_USERNAME: ${CI_REGISTRY_USER}
    APPTAINER_DOCKER_PASSWORD: ${CI_REGISTRY_PASSWORD}
  script:
    - apk add curl
    - curl -T ${CI_PROJECT_NAME}.sif --user "anonymous:csi-linux-admins@duke.edu" "ftp://research-containers-01.oit.duke.edu/incoming/${CI_PROJECT_ROOT_NAMESPACE}:${CI_PROJECT_NAME}_latest.sif"
    - apptainer push ${CI_PROJECT_NAME}.sif "oras://${CI_REGISTRY_IMAGE}/${CI_PROJECT_NAME}:latest"

deploy_tag:
  stage: deploy_tag
  rules:
    - if: '$CI_COMMIT_TAG != null'
  variables:
    APPTAINER_DOCKER_USERNAME: ${CI_REGISTRY_USER}
    APPTAINER_DOCKER_PASSWORD: ${CI_REGISTRY_PASSWORD}
  script:
    - apk add curl
    - curl -T ${CI_PROJECT_NAME}.sif --user "anonymous:csi-linux-admins@duke.edu" "ftp://research-containers-01.oit.duke.edu/incoming/${CI_PROJECT_ROOT_NAMESPACE}:${CI_PROJECT_NAME}_${CI_COMMIT_TAG}.sif"
    - apptainer push ${CI_PROJECT_NAME}.sif "oras://${CI_REGISTRY_IMAGE}/${CI_PROJECT_NAME}:${CI_COMMIT_TAG}"
